###################################################
### chunk number 1: 
###################################################
#line 72 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
library(editrules)
source("pic.R")


###################################################
### chunk number 2: 
###################################################
#line 203 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
E <- editmatrix(c(
"t  == ct + p" ,
"ct == ch + cp",
"p  <= 0.6*t",
"ct <= 0.3*t",
"cp <= 0.3*t",
"t  >  0",
"ch >  0",
"cp >  0",
"ct >  0"), normalize=TRUE)
E


###################################################
### chunk number 3: 
###################################################
#line 235 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
data(edits)
edits
editmatrix(edits)


###################################################
### chunk number 4: 
###################################################
#line 313 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
# define two records in a data.frame
dat <- data.frame(
  t = c(1000, 1200),
 ct = c(400,  200),
 ch = c(100,  350),
 cp = c(200,  575),
 p =  c(500,  652 ))
# check for violated edits
violatedEdits(E,dat)


###################################################
### chunk number 5: 
###################################################
#line 455 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
substValue(E,"t",10)


###################################################
### chunk number 6: 
###################################################
#line 501 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
(E2 <- editmatrix(c("2*x1 + x2 -x3 == 8",
                  "2*x3 + 11 == 3*x1 + x2", 
                  "x2 + 2*x3 + 3 == 2*x1")
                ))
echelon(E2)


###################################################
### chunk number 7: 
###################################################
#line 648 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
eliminate(E,"t")
F <- E
for ( var in c("t","cp","p") ) F <- eliminate(F,var)
F


###################################################
### chunk number 8: 
###################################################
#line 972 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
E <- editmatrix(c(
    "x + y == z",
    "x > 0",
    "y > 0",
    "z > 0"))

dat <- data.frame(
    x = c(1,-1,1),
    y = c(-1,1,1),
    z = c(2,0,2))

# localize all errors in the data
localizeErrors(E,dat)


###################################################
### chunk number 9: 
###################################################
#line 1028 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
E1 = editmatrix(c(
    "y >  x - 1",
    "y > -x + 3",
    "y <  x + 1",
    "y < -x + 5"))
bt <- errorLocalizer(E1, c(x=2,y=-1))
bt$searchNext()
bt$duration
bt$maxdurationExceeded
bt$searchNext()


###################################################
### chunk number 10: 
###################################################
#line 1076 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
E <- editmatrix(c("p + c == t"))
r <- c(p=755, c=125, t=200)
bt <- errorLocalizer(E, r)


###################################################
### chunk number 11: 
###################################################
#line 1083 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
bt$searchNext()$adapt
bt$searchNext()$adapt
bt$searchNext()$adapt


###################################################
### chunk number 12: 
###################################################
#line 1091 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
bt <- errorLocalizer(E, r, weight=c(1,1,2))
bt$searchNext()$adapt
bt$searchNext()$adapt
bt$searchNext()$adapt


###################################################
### chunk number 13: 
###################################################
#line 1105 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
E <- editmatrix(c(
        "p + c == t",
        "c - 0.6*t >= 0"))
bt <- errorLocalizer(E, r)
bt$searchNext()$adapt
bt$searchNext()$adapt
bt$searchNext()$adapt


###################################################
### chunk number 14: 
###################################################
#line 1121 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
# An example with missing data.
E <- editmatrix(c(
    "p + c1 + c2 == t",
    "c1 - 0.3*t >= 0",
    "p > 0",
    "c1 > 0",
    "c2 > 0",
    "t > 0"))
x <- c(p=755, c1=50, c2=NA,t=200)
bt <- errorLocalizer(E,x)
bt$searchNext()$adapt
bt$searchNext()$adapt
(s <- bt$searchNext()$adapt)


###################################################
### chunk number 15: 
###################################################
#line 1139 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
substValue(E,names(x)[!s],x[!s])


###################################################
### chunk number 16: 
###################################################
#line 1334 "d:/Rcompile/CRANpkg/local/2.12/editrules/inst/doc/editrules-linear.Rnw"
bt <- backtracker(
    isSolution = {  # check for solution or pruning
        w <- sum(weight[adapt])
        if ( isObviouslyInfeasible(.E) || w > wsol ) return(FALSE)
        if (length(.totreat) == 0){
            wsol <<- w
            adapt <- adapt 
            return(TRUE)
        }
    },
    choiceLeft = {  # things to do in the left node
        .var <- .totreat[1]
        .E <- substValue(.E, .var , r[.var])
        .totreat <- .totreat[-1]
                              
        adapt[.var] <- FALSE
    },
    choiceRight = { # things to do in the right node
        .var <- .totreat[1]
        .E <- eliminate(.E, .var)
        .totreat <- .totreat[-1]
                              
        adapt[.var] <- TRUE
    },
    # Initialize variables in root node
    .E = editmatrix(c("y > x-1 ","y > -x+3")),
    .totreat = c("x","y"),
    r = c(x=2,y=-1),
    adapt = c(x=FALSE, y=FALSE),
    weight = c(1,1),        
    wsol = 2                
)
bt$searchNext()


